package ti.mashine.urm;

public class ProgramConstants {
    public static final Integer INCREMENT_INSTRUCTION_FLAG=-1;
    
    public static final Integer INSTRUCTIONS_ARRAY_SET=1;
    public static final Integer REGISTER_STATE_CHANGED=2;
    public static final Integer INSTRUCTION_CHANGED=3;
    public static final Integer MASTER_REFRESH_WHOLE_MODEL_LOADED=4;
 
    public static final Integer RUN_AT_ONCE_PROCESS=5;
    public static final Integer RUN_STEP_BY_STEP=6;
    
    public static final Integer REGISTER_SIZE=1000;
    public static final Integer INSTRUCTION_ARRAY_SIZE=1000;
    public static final String REGISTER_PREFIX="r";
    public static final String NULL_INSTRUCTION="empty";
    public static final Integer REGISTER_HEIGHT=50;
    public static final Integer REGSITER_WIDTH=30;
    public static final Integer MAXIMUM_RUN_TIME=7000;
    public static final Integer MAXIMUM_NUMBER_OF_ARGUMENTS=10;
    
    //tokens
    public static final String NEW_PROGRAM_TOKEN="nova";
    public static final Integer SPECIAL_ARGUMENT_VALUE=0;
    public static final String LITERAL_ADRESSING="#";
    public static final String RECURSIVE_REFERENCE="this";
    
    public static final String SAMPLE_PROGRAM="Ovo je primer programa koji sabira 2 broja:\n\n" +
    		"J(1,2,4);\nS(0);\nS(2);\nJ(1,1,0);\n\n" +
    		"1. Pre nego sto iskompajlirate unesite vrednosti u registar i potvrdite dugmetom (set register)\n\n" +
    		"2. Nakon kompajliranja dobicete izgled svih instrukcija smestenih u memoriju i njihovih memorijskih lokacija\n\n" +
    		"3. Pritiskom na dugme run izvrsava se ceo program odjednom, ukoliko se ne izvrshi za "+ProgramConstants.MAXIMUM_RUN_TIME+" milisecundi\n" +
    				"\tpredpostavlja se da je program nezaustavljiv.\n\n" +
    		"4. Strelicama se vracate po jedan korak u nazad (<<<), to jest ulazite u step-by step izvrsavanje (>>>)\n\n" +
    		"5. Shto se tice editovanja koda jedini potrebni uslovi su:\n" +
    		"da posle svake instrukcije postoji tacka zarez, a format zapisa instrukcija je: \n\n" +
    		"\tS(m)\n" +
    		"\tZ(m)\n" +
    		"\tT(m,n) gde je m registar iz kojeg se upisuje sadrzaj a n ciljni\n" +
    		"\tJ(m, n, p)\n\n" +
    		"6. Nakon promene u registru potrebno je potvrditi sadrzaj, klikom na dugme desno od registra.\n"+
    		"Rad sa potprogramima:\n\n" +
    		"Program koji je vec prethodno sacuvan, a ubacuje se u neki drugi predstavlja potprogram. \n" +
    		"Ubacivanje se vrsi prostim ukucavanjem imena potprogram i njegovih argumenata, probajte ctr+space za automatski unos.\n" +
    		"VAZNO! Posle povratka iz potprograma rezultat se upije u poslednji registar tj. r"+(ProgramConstants.REGISTER_SIZE-1)+"\n" +
    				"nakon cega se moze prebaciti na odgovarajuce mesto instrukcijom transfera. Morate o tome sami da vodite racuna:)\n" +
    				"JOSH JEDNA VAZNA STVAR! U slucaju divergencije programa tj. neprestanka izvrsavanja nakon "+ProgramConstants.MAXIMUM_RUN_TIME+" milisecundi\n" +
    						"skace se na instrukciju "+(ProgramConstants.INSTRUCTION_ARRAY_SIZE-1)+" tako da tamo treba da upishete exception komandu.\n" +
    								"Ova poslednja komanda se ne razmatra u dubinu programa\n\n\n"+
    		"\t Autor student Matf-a Aleksandar Kartelj 322/06";
 
}